diff --git a/src/fread.c b/src/fread.c
index aa6cc4bd2..e98558201 100644
--- a/src/fread.c
+++ b/src/fread.c
@@ -2244,7 +2244,7 @@ int freadMain(freadMainArgs _args) {
       if (hasPrinted || verbose) DTPRINT("Rereading %d columns due to out-of-sample type exceptions.\n", nTypeBumpCols);
       if (verbose) DTPRINT("%s", typeBumpMsg);
       // TODO - construct and output the copy and pastable colClasses argument so user can avoid the reread time in future.
-      free(typeBumpMsg);
+      free(typeBumpMsg); typeBumpMsg=NULL; typeBumpMsgSize=0;
     }
   } else {
     tReread = wallclock();
diff --git a/src/freadR.c b/src/freadR.c
index 9a6d6c2e9..23295a787 100644
--- a/src/freadR.c
+++ b/src/freadR.c
@@ -380,6 +380,7 @@ void setFinalNrow(size_t nrow) {
       SET_TRUELENGTH(VECTOR_ELT(DT,i), nrow);
     }
   }
+  R_FlushConsole(); // # 2481. Just a convenient place; nothing per se to do with setFinalNrow()
 }
 
 
